<?php
 class edgeio {
	  var $edgeioconf;
	  var $conf;
	  var $rss;
  
  function edgeio(&$configuration) {
	  	  // create lastRSS object
	  $this->edgeioconf = $configuration;
	  $this->rss = new lastRSS; 
	  $this->rss->cache_dir = $this->edgeioconf["CACHE_PATH"]; 
	  $this->rss->cache_time = $this->edgeioconf["CACHE_TIME"]; // one hour
	
	  //create config object
	  //really need to cache it and instantiate only so often 
	  $c = new Configuration();
	  if($this->edgeioconf["CONF_URL"]!=''){
	  	$cn = array('url'=>$this->edgeioconf["CONF_URL"]);
	  }else{
	  	$cn = array('file'=>$this->edgeioconf["CONF_FILE"]);
	  }
	  
	  $c->parse($cn);
	  $this->conf = $c->items['configuration'];
    }
  
 function ShowOneRSS($url) {
 	
    parse_str($_SERVER['QUERY_STRING'],$url_params);

		unset($url_params['edgeio_search']);
		unset($url_params['edgeop']);
		$url_params['from'] = 1;		
		$url_params['limit'] = $this->conf['limit']*2 ;
		$base_query = http_build_query($url_params);           
		//unset($url_params['tpl']);
		unset($url_params['rss']);
		
        if($url_params['n']!=''){
           //this is a histogram request, swap base urls
          $url = str_replace('&n='.$url_params['n'],'',$url); 
    	  $url = str_replace($this->my_preg_match("'/s2/(.*?).html'si", $url),$url_params['n'],$url);
    	  unset($url_params['n']);	      
        }
        
        if($url_params['bc']!=''){
           //this is a histogram request, swap base urls
          $url = $url . '&boardCategory='.strtolower($url_params['bc']);
    	  unset($url_params['bc']);	      
        }
        
        //whats left make an url
        $url = trim($url,'&') .'&'.  http_build_query($url_params);
        
        if(($url_params['edgeio_location_code']!='')&&($url_params['edgeio_use_location']!='')&&($url_params['set_url_str']=='')){
           //this is a histogram request, swap base urls
           
          $url = $url . '&locStr='.urlencode(strtolower($url_params['edgeio_location_code']));
        }
        
          $url=trim($url,'&') . '&ver=' . urlencode($this->conf['ver']) . '&md=' . urlencode($this->conf['target']) . '&h='.urlencode($_SERVER['SERVER_NAME']);
        
        unset($url_params['edgeio_location_code']);	 
        unset($url_params['edgeio_use_location']);	 
        
        if($_REQUEST['debug']){
         echo $url;
        }
        
    if ($rs = $this->rss->get($url)){
         
          $list = "<div id='edgeio_listings'>\n";
          $i=1;
          $n=0;
          
          $timestamp = array();
          
          foreach ($rs['items'] as $key=>$row) {
           $timestamp[$key] = strtotime($row['pubDate']);
           $rs['items'][$key]['timestamp'] = strtotime($row['pubDate']);
          }
          
          array_multisort($timestamp, SORT_DESC, $rs['items']);
          
          if(count($rs['items'])>$this->conf['limit']){
           $rs['items'] = array_slice($rs['items'],0,$this->conf['limit']);
          } 
          
            foreach ($rs['items'] as $item) {
             if($item[title]!=''){
            	
            	$desc = explode('<p>',html_entity_decode($item['description'])); // a hack to break description in half for better formatting we laways get bulk description in first p element
				$before = $desc[0];
				unset($desc[0]);
				$after = '<p>'.implode('<p>',$desc).'</p>';
            
				if($this->conf['target']=='cpc'){
				  $list .= "\t<div class='edgeio_item'><div class='edgeio_item_title'><a href=\"".$item[link]."?tpl=".$_REQUEST['tpl']."\">$item[title]</a></div><span class=\"edgeio_item_date\">".date('F j, Y', strtotime($item['pubDate']))."</span>\n";
				  $list .= "<div class='edgeio_item_description' id='item_".$i."'>".$before.nl2br($after)."</div></div>";
				}elseif($this->conf['target']=='inline'){
				  $list .= "\t<div class='edgeio_item'><div class='edgeio_item_title'><a href=\"javascript:edgeio_click()\" onclick=\"edgeio_show('item_$i')\"><span id='item_".$i."_title'><img src=\"http://www.edgeio.com/img/sp.gif\" id='item_".$i."_active' class='edgeio_active' width=\"3\" height=\"3\" />$item[title]</span></a></div><span class=\"edgeio_item_date\">".date('F j, Y', strtotime($item['pubDate']))."</span>\n";
				  $list .= "<div class='edgeio_item_description' id='item_".$i."'>".$before.nl2br($after)."</div></div>";
				}elseif($this->conf['target']=='put'){
					if($_REQUEST['edgeop']){
					  if($_REQUEST['edgeop']==$item[link]){ 	
				 	    $list .= "\t<div class='edgeio_item'><div class='edgeio_item_title'><a href=\"$item[link]\">$item[title]</a></div><span class=\"edgeio_item_date\">".date('F j, Y', strtotime($item['pubDate']))."</span>\n";
					    $list .= "<div class='edgeio_item_description_op' id='item_".$i."'>".$before.nl2br($after)."</div></div>";
					  }  
				   }else{
				 	  $list .= "\t<div class='edgeio_item'><div class='edgeio_item_title'><a href=\"".$_SERVER['REQUEST_URI']."&edgeop=".urlencode($item[link])."\">$item[title]</a></div><span class=\"edgeio_item_date\">".date('F j, Y', strtotime($item['pubDate']))."</span>\n";
					  $list .= "<div class='edgeio_item_description' id='item_".$i."'>".$before.nl2br($after)."</div></div>";
					  $n=0;
				   }		 				  

				}else{
				  $list .= "\t<div class='edgeio_item'><div class='edgeio_item_title'><a href=\"$item[link]\" target=\"$this->conf['target]\">$item[title]</a></div><span class=\"edgeio_item_date\">".date('F j, Y', strtotime($item['pubDate']))."</span>\n";	
				  $list .= "<div class='edgeio_item_description' id='item_".$i."'>".$before.nl2br($after)."</div></div></div>";					
				}
				

            	$i++;
             }	
            }
            if ($rs['items_count'] <= 0) { $list .= "<div class='edgeio_empty'>Sorry, no search is empty</div>"; }
            $list .= "</div>\n";
         
    }else{
        $list .= "<div class='edgeio_empty'>Sorry: Cant connect to $url</div>\n<br />";
        // you will probably hide this message in a live version
    }
    
    return array('listings'=>$list, 'ccategories'=>$rs['ccategories'], 'histogram'=>$rs['histogram'],'basequery'=>$base_query);
 }
 
function load_edgeio_template($template){
 $file = $this->edgeioconf["DIR_WS_META"] . $template;

 //TODO check if it is a url
 
 if (strpos($template,'http://')!== false){
   $content =$this->get_template($template);	
 }else{
   if(!($fp = fopen($file, "r"))) {
	 die("could not open template file " . $file);
	}
 	 $content = fread($fp, filesize($file));
	 fclose($fp);
 }	 
	 return $content;
}

function get_template($url) {
	// If CACHE ENABLED
	if ($this->edgeioconf["CACHE_PATH"] != '') {
		$cache_file = $this->edgeioconf["CACHE_PATH"] . '/template_' . md5($url);
		$timedif = @(time() - filemtime($cache_file));
		if ($timedif < $this->edgeioconf["CACHE_TIME"]) {
			// cached file is fresh enough, return cached array
			$result = unserialize(join('', file($cache_file)));
			// set 'cached' to 1 only if cached file is correct
			if ($result) $result['cached'] = 1;
		} else {
			// cached file is too old, create new
			if($result = $this->get_url($url)){
				$serialized = serialize($result);
				if ($f = @fopen($cache_file, 'w')) {
					fwrite ($f, $serialized, strlen($serialized));
					fclose($f);
				}
				if ($result) $result['cached'] = 0;
			}else{
				// cant connect re use stale data
				$result = unserialize(join('', file($cache_file)));
				// set 'cached' to 1 only if cached file is correct
				if ($result) $result['cached'] = 1;
			}
		}
	}
	// If CACHE DISABLED >> load and parse the file directly
	else {
		$result = $this->get_url($url);
		if ($result) $result['cached'] = 0;
	}
	return $result;
}
	
function get_url($_url){
    $this->original_url=$_url;
    $url = parse_url($_url);
    $http_client = new edgeio_http( HTTP_V11, false);
    $http_client->host = $url['host'];
    
    if($url['query']!=''){
      $query = $url['path'] . '?' . $url[query]; 
    }else{
      $query = $url['path'];
    }
    
    if ( $http_client->get($query) == HTTP_STATUS_OK){
        $rs = $http_client->get_response_body();
        unset( $http_client );
        return $rs;
    }else{
        unset( $http_client );
        $error = 'Server returned ' .  $http_client->status;
        return false;
    }
}

function my_preg_match ($pattern, $subject) {
  preg_match($pattern, $subject, $out);
	if(isset($out[1])) {
		return trim($out[1]);
	} else {
		return '';
	}
}

function get_edgeio_classifieds(){
  if(($this->conf['base_rss']!='')&&($this->edgeioconf['locStr']!='')){
  	$this->conf['base_rss'] = $this->conf['base_rss'] . '&set_location_str=' . urlencode($this->edgeioconf['locStr']);
  }
  
  $this->conf['base'] = $_SERVER['QUERY_STRING'];
  $this->conf['templates']['index']['layout_index'] = $this->load_edgeio_template($this->conf['templates']['index']['layout_index']);
  $this->conf['templates']['index']['layout_index_board'] = $this->load_edgeio_template($this->conf['templates']['index']['layout_index_board']);
  $this->conf['templates']['histogram']['index'] = $this->load_edgeio_template($this->conf['templates']['histogram']['index']);
  $this->conf['templates']['histogram']['detail'] = $this->load_edgeio_template($this->conf['templates']['histogram']['detail']);
  $this->conf['templates']['widgets']['location'] = $this->load_edgeio_template($this->conf['templates']['widgets']['location']);
  
  if($this->conf['templates']['style']==''){//use default
    $this->conf['templates']['style'] = $this->load_edgeio_template('default.style.css');
  }elseif($this->conf['templates']['style']=='none'){ //uses external
    $this->conf['templates']['style'] = '';
  }else{
	$this->conf['templates']['style'] = $this->load_edgeio_template($this->conf['templates']['style']);
  }    

  $b = new Board();
    
  $b->parse($this->conf);
  
  $style = '<style type="text/css">'.$this->conf['templates']['style'].'</style>';  
  
  if($_REQUEST['tpl']==''){//initial req
    $r='';
    if(($this->conf['templates']['index']['multi']=='true')){//this is a multi board index
      //output index;
      $r = $style.$b->drawindex($this->conf);
      return $r;
    }else{
    //this is a single board so lets redirect to board entry
       if($this->conf['redirect']=='meta'){
       	echo '<META http-equiv="refresh" content="1;URL='.$b->parse($this->conf,true).'">';
        exit; 
      } elseif($this->conf['redirect']=='js'){
       	echo '<script type="text/javascript">window.location="'.$b->parse($this->conf,true).'";</script>';
        exit; 
      }else{	
        header("Location: ".$b->parse($this->conf,true));
        exit;
       }	
    }
  }else{
    //get the rss feed and use specific template to display it
	$board=explode('-',$_REQUEST['rss']);
	$rss_url = $this->conf['boards'][$board[0]]['categories']['category'][$board[1]]['rss'];
	
	if(($_REQUEST['edgeio_search']!='')&&($_REQUEST['edgeio_search']!='search...')){
	 $search = '&q='.urlencode($_REQUEST['edgeio_search']);
	}else{
	 $search = '';  
	}

	if(!substr($rss_url,'?')){
	  $rss_url .= '?'.$search;
	}else{
	  $rss_url .= '&'.$search;
	}
	
	if(!$target=$this->conf['boards'][$board[0]]['categories']['category'][$board[1]]['target']){
	 if(!$target = $this->conf['boards'][$board[0]]['target']){
	  $target = $this->conf['target'];	
	 }	
	}
		
	$content = $this->ShowOneRss($rss_url,$target);
	
	if(!$template=$this->conf['boards'][$board[0]]['categories']['category'][$board[1]]['cl_template']){
	 if(!$template = $this->conf['boards'][$board[0]]['cl_template']){
	  $template = $this->conf['templates']['default_cl_template']; 	
	 }	
	}
	
	if(!$post_url=$this->conf['boards'][$board[0]]['categories']['category'][$board[1]]['post_url']){
	 if(!$post_url = $this->conf['boards'][$board[0]]['post_url']){
	  $post_url = $this->conf['post_url']; 	
	 }	
	}
	
	if(!$post_label=$this->conf['boards'][$board[0]]['categories']['category'][$board[1]]['post_label']){
	 if(!$post_label = $this->conf['boards'][$board[0]]['post_label']){
	  $post_label = $this->conf['templates']['post_label']; 	
	 }	
	}
	
	$template = $this->load_edgeio_template($template); //locat condenced listing template file
	
	$bpath = explode('?',$_SERVER['REQUEST_URI']);
	parse_str($_SERVER['QUERY_STRING'],$prms);
	  foreach($prms as $key=>$value){
		if(($key=='edgeio_location_code')||($key=='edgeio_use_location')){
		 if($key=='edgeio_location_code') $edgeio_location_code = $value;
		 if($key=='edgeio_use_location') $edgeio_use_location = 'checked';
		  	
		}else{
		  $sf .= '<input type="hidden" name="'.$key.'" value="'.$value.'" />'."\n"; //for search we want escape location	
		}
	
		  $hf .= '<input type="hidden" name="'.$key.'" value="'.$value.'" />'."\n";
	  }
	 
	$searchform = "<form name=\"EDGEIOSEARCH\" id=\"EDGEIOSEARCH\" action=\"".$bpath[0]."\" method=\"GET\"><input type=\"text\" value=\"search...\" onfocus=\"if(this.value == 'search...') { this.value = ''; }\" onblur=\"if(this.value == '') { this.value = 'search...'; }\" name=\"edgeio_search\" id=\"edgeio_search\" />".$hf."<a href=\"#\" onClick=\"document.EDGEIOSEARCH.submit();return false;\">&raquo;</a></form>";
	if(!$this->conf['boards'][$board[0]]['categories']['category'][$board[1]]['location']){
	 $locationform =  "<form name=\"EDGEIOLOCATION\" id=\"EDGEIOLOCATION\" action=\"".$bpath[0]."\" method=\"GET\"><input type=\"checkbox\"  id=\"edgeio_use_location\" name=\"edgeio_use_location\" value=\"1\" ".$edgeio_use_location." /> show listings around <input type=\"text\" size=\"10\" value=\"".$edgeio_location_code."\" name=\"edgeio_location_code\" id=\"edgeio_location_code\"  />".$sf."<a href=\"#\" onClick=\"document.EDGEIOLOCATION.submit();return false;\" class=\"edgeio_location_button\">update</a></form>";
	}else{
	 $locationform = '';	
	}
	$crumb = '<a href="'.$bpath[0].'">' . $this->conf['title'].'</a> - '.$board[3];
	$location = $this->conf['templates']['widgets']['location'];
  
	
	$template = str_replace("<#edgeiocrumb#>",$crumb,$template);
	$template = str_replace("<#edgeiolocation#>",$locationform,$template);
	$template = str_replace("<#edgeiosearch#>",$searchform,$template);
	$template = str_replace("<#edgeiopost#>",'<div id="edgeio_post"><a href="'.$post_url.'?tpl='.$_REQUEST['tpl'].'">'.$post_label.'</a></div>',$template);
	$template = str_replace("<#edgeioboard#>",$b->drawindexdetails($this->conf,$content['ccategories'],$board),$template);
	$template = str_replace("<#edgeiohistogram#>",$b->build_histogram($content['histogram'],$this->conf),$template);
	$template = str_replace("<#edgeiolisting#>",$content['listings'],$template);
 
 	$res = $style.$template;
 	
	return $res;
    }
   }//
    
 }//class end
?>